import Taro, { Component } from '@tarojs/taro'
import { View,Button } from '@tarojs/components'
import { AtTag, AtButton} from 'taro-ui'


import URL from '../../serviceAPI.config'

import './sideBarFilterComponent.scss'

class sideBarFilterComponent extends Component {
    // 项目配置
    config = {
        navigationBarTitleText: '筛选'
    }
    constructor() {
        super(...arguments)
        this.state = {
            isActive:false
        }
    }
    onClick(value){
        console.log(value)
    }
    getSearchParam(){
        Taro.request({
            url: URL.GetSearchParam,
            method: 'POST',
            dataType: 'json',
            data: {
                goods: JSON.stringify({
                    shop_name: false,
                    shop_id: 808,
                    shop_class_id: "",
                    goods_type: 12
                }),
                goodsSpec: JSON.stringify([]),
                goodsParam: JSON.stringify([]),
                goodsParamExt: JSON.stringify([]),

            },
            header: {
                'content-type': 'application/x-www-form-urlencoded',
                'X-Requested-With': 'XMLHttpRequest'
            }
        })
            .then(res => {
                console.log('param',res)
            })
    }
    getSearchResult(){
        Taro.request({
            url: URL.SearchResult,
            method: 'POST',
            dataType: 'json',
            data: {
                goods: JSON.stringify({
                    curr_page: 1,
                    page_count: 50,
                    shop_name: false,
                    shop_id: 808,
                    config_id: 4,
                    shop_class_id: '',
                    goods_type:12
                }),
                goodsSpec: JSON.stringify([]),
                goodsParam: JSON.stringify([]),
                goodsParamExt: JSON.stringify([]),

            },
            header: {
                'content-type': 'application/x-www-form-urlencoded',
                'X-Requested-With': 'XMLHttpRequest'
            }
        })
            .then(res => {
                console.log('result',res)
            })
    }

    componentWillMount() {
        
    }
    componentDidMount() {
        this.getSearchParam()
        this.getSearchResult()
    }

    componentDidShow() { }

    componentDidHide() { }
    render() {
        
        const goodsClass = this.props.FilterText?this.props.FilterText.goods_class:null
        const goodsType = this.props.FilterText?this.props.FilterText.goods_type:null
        const widthness = this.props.FilterText?this.props.FilterText.goodsParamExt['5'].param_value[0]:null
       
        const goodsParam = this.props.FilterText? this.props.FilterText.goodsParam:null
// 分类 
        const goodsClassElementsArray=goodsClass.map((item,index)=>{
            return  <AtTag style='margin-left:5px' key={index}
              name={item.class_name}
              type='primary'
              active={this.state.isActive}
              onClick={this.onClick.bind(this)}
            >{item.class_name}</AtTag>
                })
// 商品类型
        const goodsTypeElementsArray=goodsType.map((item,index)=>{
            return  <AtTag style='margin-left:5px' key={index}
              name={item.goods_type_ch_name}
              type='primary'
              active={this.state.isActive}
              onClick={this.onClick.bind(this)}
            >{item.goods_type_ch_name}</AtTag>
                })
//---------
        const goodsParamElementsArray = goodsParam.map((item,index)=>{
            return <View key={index}><View className='title' >{item.param_name}</View>
                <View className='button-box'>
                <AtTag style='margin-left:5px' 
                  name={item.param_value[0]}
                  type='primary'
                  active={this.state.isActive}
                  onClick={this.onClick.bind(this)}
                >{item.param_value[0]}</AtTag>
                </View>
            </View> 
        })
// 宽度
        return (
            <View className='filter-box'>
                <View className='title'>分类</View>
                <View className='button-box'>{goodsClassElementsArray}</View>
                <View className='title'>商品类型</View>
                <View className='button-box'>{goodsTypeElementsArray}</View>
                {goodsParamElementsArray}   
                <View className='title'>宽度</View>
                <View className='button-box'>
                    <AtTag style='margin-left:5px' 
                      name={widthness.value_desc}
                      type='primary'
                      active={this.state.isActive}
                      onClick={this.onClick.bind(this)}
                    >{widthness.value_desc}</AtTag>
                    
                </View>
                <View className='confirm-button'>
                    <Button  className='button' type='primary' size='mini' style='background-color:#FF9900' >确认</Button>
                    <Button className='button' type='primary' size='mini' style='background-color:#FF9900'>重置</Button>
                </View>
            </View>
        )
    }
}

export default sideBarFilterComponent